#include <iostream>
#include <vector>
#include <set>
#include "testlib.h"

using namespace std;

int p, t, m;
vector <vector <int> > gr;

inline pair <int, int> readAndCheckAnswer(InStream& in) {
	vector <bool> can_write(p, 1);

	int a_p = in.readInt(0, p);
	int a_t = in.readInt(1, t);
	set <int> st;
	for (int i = 0; i < a_t; ++i) {
		int a = in.readInt(1, t) - 1;
		if (st.find(a) != st.end()) {
			in.quitf(_wa, "There are same numbers in sequence");
		}
		st.insert(a);
		for (auto u: gr[a]) {
			can_write[u] = 0;
		}
	}
	int cnt = 0;
	for (auto i: can_write) {
		cnt += i;
	}
	if (cnt != a_p) {
		in.quitf(_wa, "Count of participant not same with participants");
	}
	return {a_p, a_t};
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    p = inf.readInt();
    t = inf.readInt();
    m = inf.readInt();

    gr.resize(t);
    for (int i = 0; i < m; ++i) {
    	int u = inf.readInt() - 1;
    	int v = inf.readInt() - 1;
    	gr[v].push_back(u);
    }

    pair <int, int> ja = readAndCheckAnswer(ans);
    pair <int, int> pa = readAndCheckAnswer(ouf);
    if (ja > pa) {
    	quitf(_wa, "Jury has better answer than participant");
    }
    if (pa > ja) {
    	quitf(_fail, "Participant has better answer than jury");
    }
    quitf(_ok, "There are %d participants and %d tasks", ja.first, ja.second);
}