#include "testlib.h"
#define MAXLEN 10000

int truncated=0;

int print (char *seq)
{
int len=strlen(seq);

printf ("%d\n",len+truncated);

if (truncated)
{
printf ("Add a\n");
printf ("Vote a\n");
}

for (int i=0;i<len;i++)
 {
  if (seq[i]<'a') printf ("Add %c\n",seq[i]-'A'+'a');
   else printf ("Vote %c\n",seq[i]);
 }
return 0;
}

int gen_psp (char *seq, int len, int freq1, int freq2)
{
 int mystack [MAXLEN];
 if (len%2==1) len--;
 int stptr=0;
 int n=0;
 while (n<len)
  {
   if (stptr) 
     if ( (rnd.next (1,freq2) <= freq1 ) || (len-n == stptr) ) 
      {
       seq[n++]=mystack[--stptr]+'a'-'A';
       continue;
      }
    seq[n++]=mystack[stptr++]='A'+rnd.next(0,25);
  }
seq[n++]=0;
return 0;
}

int swap_psp (char *seq)
{
int len=strlen(seq);
int from=rnd.next(0,len-2);
char a=seq[from];
seq[from]=seq[from+1];
seq[from+1]=a;
return 0;
}

int shift_psp (char *seq)
{
int len=strlen(seq);
int from=rnd.next(0,len-1);
if ((seq[from] || 0x20) == 'z') seq[from]--;
 else seq[from]++;
return 0;
}

int trunc_psp (char *seq)
{
int len=strlen(seq);
if (seq[len-2]<'a') seq [len-3]=seq[len-2];
seq[len-2]=0;
truncated=2;
return 0;
}

int random (char *seq, int N)
{
for (int i=0;i<N;i++)
 {
  if (rnd.next(0,1)) seq[i]='A';
  else seq[i]='a';
  seq[i]+=rnd.next(0,25);
 } 
seq[N]=0;
return 0;
}

int main(int argc, char **argv)
{
registerGen(argc,argv,1);
char psp[1010];
int N,k,freq1,freq2;
sscanf (argv[2],"%d",&N);
sscanf (argv[3],"%d/%d",&freq1,&freq2);
gen_psp (psp,N,freq1,freq2);

if (strcmp (argv[1],"swap")==0)
{
sscanf (argv[4],"%d",&k);
 for (int i=0;i<k;i++) swap_psp(psp);
}

if (strcmp (argv[1],"shift")==0)
{
 shift_psp(psp);
}

if (strcmp (argv[1],"truncate")==0)
{
 trunc_psp(psp);
}

if (strcmp (argv[1],"random")==0)
{
 random (psp,N);
}

print (psp);
return 0;
}