#include <stdio.h>

#define BASE 26LL
#define MOD 1000000007LL

/*
1*4 + x^1*5+... = 

f(k) x^k+..+x^n=x^k (1+..+x^{n-k})=x^k(x^{n-k+1)-1)= (x^{n+1}-x^k)/(x-1)


3f(1) + f(1)+f(2)+..+f(n)=nx^{n+1}-x^n...-1 / (x-1) = (nx^(n+1)-(x^(n+1)-1)/(x-1))/(x-1)
*/

long long mul (long long a, long long b)
{
return (a*b)%MOD;
}

long long add (long long a, long long b)
{
return (a+b)%MOD;
}

long long sub (long long a, long long b)
{
return ((a-b)%MOD+MOD)%MOD;
}

long long fastpow (long long a, long long n)
{
 if (n==0LL) return 1LL;
 if (n%2LL!=0LL) return mul (a,fastpow(a,n-1LL));
 long long tmp=fastpow (a,n/2LL);
 return mul (tmp, tmp);
}

long long ddiv (long long a, long long b)
{
 return  mul (a,fastpow (b,MOD-2));
}

int main()
{
long long N,ans=0LL;
scanf ("%lld",&N);

for (long long i=4LL;i<=N;i++)
 {
  ans=add (ans, mul (i, fastpow (26LL,i-4LL)));
 }
printf ("%lld\n",ans);
return 0;
}