// NearestRandomPoint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//#include "pch.h"
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cassert>
#include <cstdlib>
#include <algorithm>
#include <cmath>


//#include <bits/stdc++.h>

using namespace std;

const long long MAXNUM = 8000000000000000000ll;
const int MAXN = 200500;
const int MAXCOORD = (1 << 18);

typedef double ld;
struct Point {
	ld x, y;
};

Point operator + (Point p1, Point p2) {
	return Point{ p1.x + p2.x, p1.y + p2.y };
}

Point operator - (Point p1, Point p2) {
	return Point{ p1.x - p2.x, p1.y - p2.y };
}

Point operator * (Point p, ld v) {
	return Point{ p.x * v, p.y * v };
}

struct Line {
	Point p{0, 0}, v{0, 0};

	bool isEmpty() const {
		return v.x == 0 && v.y == 0;
	}

	bool isVertical() const {
		return v.x == 0;
	}

	ld getY(ld x) {
		return p.y + v.y * (x - p.x) / v.x;
	}

/*	ld getY(long long x) {
		return getY((ld)x);
	}*/
};

int readInt() {
	int v;
	scanf("%d", &v);
	return v;
}

struct Tree {
	Line* tree;

	Tree()
	{
		tree = new Line[MAXCOORD * 4];
		for (int i = 0; i < MAXCOORD * 4; ++i)
			tree[i] = Line{ Point{0, 0}, Point{1, 0} };
	}

	~Tree() {
		delete[] tree;
	}

	void setLineLocal(int v, int lx, int rx, Line line) {
		Line vline = tree[v];
		ld val1l = line.getY(lx);
		ld val1r = line.getY(rx-1);
		ld val2l = vline.getY(lx);
		ld val2r = vline.getY(rx - 1);

		if (val1l <= val2l && val1r <= val2r)
			return;
		if (val2l <= val1l && val2r <= val1r) {
			tree[v] = line;
			return;
		}

		if (val1l < val2l) {
			swap(line, vline);
			swap(val1l, val2l);
			swap(val1r, val2r);
		}

		int midx = (lx + rx) / 2;
		ld val1mid = line.getY(midx);
		ld val2mid = vline.getY(midx);
		if (val2mid <= val1mid) {
			tree[v] = line;
			setLineLocal(v * 2 + 1, midx, rx, vline);
		}
		else {
			tree[v] = vline;
			setLineLocal(v * 2, lx, midx, line);
		}
	}

	void setLine(Line l) {
		setLineLocal(1, 0, MAXCOORD, l);
	}

	ld getY(int x) {
		assert(0 <= x && x < MAXCOORD);
		ld y = tree[1].getY(x);
		int l = 0;
		int r = MAXCOORD;
		int v = 1;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (x < mid) {
				r = mid;
				v = v * 2;
			}
			else {
				l = mid;
				v = v * 2 + 1;
			}
			y = max(y, tree[v].getY(x));
		}
		return y;
	}
};

Point ps[MAXN];

vector<ld> getYsDown(const vector<Line> &lines, int lx, int rx) {
	Tree tree;
	for (Line l : lines)
		tree.setLine(l);
	vector<ld> ys;
	for (int x = lx; x <= rx; ++x)
		ys.push_back(tree.getY(x));
	return ys;
}

vector<ld> getYsUp(vector<Line> lines, int lx, int rx, int Y) {
	ld rY = Y;
	for (int i = 0; i < (int)lines.size(); ++i) {
		lines[i].p.y = rY - lines[i].p.y;
		lines[i].v.y = -lines[i].v.y;
		//lines[i].v.x = -lines[i].v.x;
	}

	vector<ld> ys = getYsDown(lines, lx, rx);
	for (int i = 0; i < (int)ys.size(); ++i)
		ys[i] = rY - ys[i];
	return ys;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int X, Y, n;
	X = readInt();
	Y = readInt();
	n = readInt();

	for (int i = 0; i < n; ++i) {
		ps[i].x = readInt();
		ps[i].y = readInt();
	}

	int lx = 0;
	int rx = X;

	vector<Line> linesDown, linesUp;
	linesDown.push_back(Line{ Point{0, 0}, Point{1, 0} });
	linesUp.push_back(Line{ Point{(ld)Y, (ld)Y}, Point{-1, 0} });

	for (int i = 1; i < n; ++i)
		if (ps[i].y == ps[0].y) {
			ld x = (ps[0].x + ps[i].x) / 2.0;
			if (ps[0].x < ps[i].x)
				rx = min((long long)rx, (long long)floor(x));
			else
				lx = max((long long)lx, (long long)ceil(x));
		}
		else {
			Point v = ps[i] - ps[0];
			v = Point{ -v.y, v.x };
			Point p = (ps[i] + ps[0]) * 0.5;
			
			if (ps[i].y < ps[0].y)
				linesDown.push_back(Line{ p, v });
			else
				linesUp.push_back(Line{ p, v });
		}
	
	vector<ld> ysDown = getYsDown(linesDown, 0, X);
	vector<ld> ysUp = getYsUp(linesUp, 0, X, Y);

	/*
	for (int i = 0; i <= X; ++i)
		cerr << ysDown[i].nom << ' ' << ysDown[i].denom << endl;
	for (int i = 0; i <= X; ++i)
		cerr << ysUp[i].nom << ' ' << ysUp[i].denom << endl;
	*/

	long long ans = 0;
	for (int x = lx; x <= rx; ++x) {
		long long lv = ceil(ysDown[x]);
		long long rv = floor(ysUp[x]);
		ans += max((long long)0, rv - lv + 1);
	}

	cout << ans << "\n";
//	long long s = X + 1;
//	s *= Y + 1;
//	long long g = findGcd(ans, s);
//	cout << ans/g << "/" <<  s / g << "\n";
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
