// NearestRandomPoint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//#include "pch.h"
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cassert>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <cassert>

//#include <bits/stdc++.h>

using namespace std;

const long long MAXNUM = 8000000000000000000ll;
const int MAXN = 200500;
const int MAXCOORD = (1 << 18);

typedef long double ld;

const ld eps = 1e-12;
bool eq0(ld x) {
	return fabsl(x) < eps;
}

bool eq(ld x, ld y) {
	return eq0(x-y);
}

int sign(ld x) {
	if (eq0(x))
		return 0;
	return ((x > 0) ? 1 : -1);
}

struct Point {
	ld x, y;
};

Point operator + (Point p1, Point p2) {
	return Point{ p1.x + p2.x, p1.y + p2.y };
}

Point operator - (Point p1, Point p2) {
	return Point{ p1.x - p2.x, p1.y - p2.y };
}

Point operator * (Point p, ld v) {
	return Point{ p.x * v, p.y * v };
}

ld operator * (Point p1, Point p2) {
	return p1.x*p2.y - p1.y*p2.x;
}

struct Line {
	Point p{0, 0}, v{0, 0};

	bool isEmpty() const {
		return v.x == 0 && v.y == 0;
	}

	bool isVertical() const {
		return v.x == 0;
	}

	ld getY(ld x) {
		return p.y + v.y * (x - p.x) / v.x;
	}

	int sign(Point pp) {
		return ::sign(v * (pp - p));
	}
/*	ld getY(long long x) {
		return getY((ld)x);
	}*/
};

bool operator < (Line l1, Line l2) {
	assert(l1.v.x > 0 && l2.v.x > 0);
	ld prod = l1.v * l2.v;
	int sgn = sign(prod);

	if (!sgn)
		return l1.sign(l2.p) > 0;
	else
		return sgn == 1;
}

Point linesIntersection(Line l1, Line l2) {
	// [l1.p + t * l1.v - l2.p, l2.v] == 0
	ld t = ((l2.p - l1.p) * l2.v) / (l1.v * l2.v);
	return l1.p + l1.v * t;
}

int readInt() {
	int v;
	scanf("%d", &v);
	return v;
}

Point ps[MAXN];


vector<ld> getYsDown(vector<Line> lines, int lx, int rx) {
	sort(lines.begin(), lines.end());
	int pos = 1;
	while (pos < (int)lines.size() && eq0(lines[pos].v * lines[pos - 1].v))
		++pos;
	//pos = 1;
	vector<Line> st(1, lines[pos-1]);
	for (int i = pos; i < (int)lines.size(); ++i) {
		Line line = lines[i];
		while (st.size() > 1 && line.sign(st.back().p) <= 0)
			st.pop_back();
		Point p = linesIntersection(st.back(), line);
		st.push_back(Line{ p, line.v });
	}

	vector<ld> ans;
	pos = 0;
	for (int x = lx; x <= rx; ++x) {
		while (pos + 1 < (int)st.size() && st[pos + 1].p.x <= x)
			++pos;
		ans.push_back(st[pos].getY(x));
	}
	return ans;
}

vector<ld> getYsUp(vector<Line> lines, int lx, int rx, int Y) {
	ld rY = Y;
	for (int i = 0; i < (int)lines.size(); ++i) {
		lines[i].p.y = rY - lines[i].p.y;
		//lines[i].v.y = -lines[i].v.y;
		lines[i].v.x = -lines[i].v.x;
	}

	vector<ld> ys = getYsDown(lines, lx, rx);
	for (int i = 0; i < (int)ys.size(); ++i)
		ys[i] = rY - ys[i];
	return ys;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int X, Y, n;
	X = readInt();
	Y = readInt();
	n = readInt();

	for (int i = 0; i < n; ++i) {
		ps[i].x = readInt();
		ps[i].y = readInt();
	}

	int lx = 0;
	int rx = X;

	vector<Line> linesDown, linesUp;
	linesDown.push_back(Line{ Point{0, 0}, Point{1, 0} });
	linesUp.push_back(Line{ Point{(ld)Y, (ld)Y}, Point{-1, 0} });

	for (int i = 1; i < n; ++i)
		if (ps[i].y == ps[0].y) {
			ld x = (ps[0].x + ps[i].x) / 2.0;
			if (ps[0].x < ps[i].x)
				rx = min((long long)rx, (long long)floor(x));
			else
				lx = max((long long)lx, (long long)ceil(x));
		}
		else {
			Point v = ps[i] - ps[0];
			v = Point{ -v.y, v.x };
			Point p = (ps[i] + ps[0]) * 0.5;
			
			if (ps[i].y < ps[0].y)
				linesDown.push_back(Line{ p, v });
			else
				linesUp.push_back(Line{ p, v });
		}
	
	vector<ld> ysDown = getYsDown(linesDown, 0, X);
	vector<ld> ysUp = getYsUp(linesUp, 0, X, Y);

	/*
	for (int i = 0; i <= X; ++i)
		cerr << ysDown[i].nom << ' ' << ysDown[i].denom << endl;
	for (int i = 0; i <= X; ++i)
		cerr << ysUp[i].nom << ' ' << ysUp[i].denom << endl;
	*/

	long long ans = 0;
	for (int x = lx; x <= rx; ++x) {
		long long lv = ceil(ysDown[x]);
		long long rv = floor(ysUp[x]);
		ans += max((long long)0, rv - lv + 1);
	}

	cout << ans << "\n";
//	long long s = X + 1;
//	s *= Y + 1;
//	long long g = findGcd(ans, s);
//	cout << ans/g << "/" <<  s / g << "\n";
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
