#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include "testlib.h"

using namespace std;

int n, m;
vector <vector <char> > room;

bool border(int x, int y) {
	return x == 0 || x == n - 1 || y == 0 || y == m - 1;
}

vector <string> pattern = {
    {".W.W"},    
    {"W.G."},
    {".G.G"},
    {"G.W."},
    {".W.W"},
    {"G.W."},
    {".G.G"},
    {"W.G."}
};

vector <string> pattern_first = {
    {".G.W"},
    {"W.G."},
    {".W.G"},
    {"..W."},
    {"...W"},
    {"..W."},
    {".W.G"},
    {"W.G."}
};

vector <string> pattern_last = {
    {"..."},
    {"W.."},
    {".W."},
    {"G.W"},
    {".G."},
    {"G.W"},
    {".W."},
    {"W.."}
};

vector <string> main_pattern(8);

void add(string &s, string &t) {
    for (auto ch: t) {
        s += ch;
    }
}

void create_main_pattern() {
    for (int i = 0; i < 8; ++i) {
        add(main_pattern[i], pattern_first[i]);
        for (int j = 0; j < (m - 9) / 4; ++j) {
            add(main_pattern[i], pattern[i]);
        }
        add(main_pattern[i], pattern_last[i]);
    }
}

void fill(int i) {
    for (int i1 = 0; i1 < 8; ++i1) {
        if (i + i1 >= n - 1) {
            break;
        }
        for (int j = 1; j < m - 1; ++j) {
            room[i + i1][j] = main_pattern[i1][j - 1];
        }
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    n = atoi(argv[1]);
    m = atoi(argv[2]);


    assert(n >= 6);
    assert(m >= 9);
    assert((n - 2) % 4 == 0);
    assert((m - 5) % 4 == 0);

    create_main_pattern();
    
    room.assign(n, vector <char> (m, 'W'));

    for (int i = 1; i + 4 < n; i += 8) {
        fill(i);
    }

    int x = n - 3;
    int y = 2;
    if ((n - 2) % 8 == 4) {
        y = m - 3;
    }
    room[x][y] = 'G';


    cout << n << " " << m << endl;
    for (auto &v: room) {
        for (auto &ch: v) {
            cout << ch;
        }
        cout << endl;
    }
    cout << "3 3" << endl;
    cout << "2 2" << endl;

    return 0;
}