#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include "testlib.h"

using namespace std;

int n, m;
vector <vector <char> > room;

bool border(int x, int y) {
	return x == 0 || x == n - 1 || y == 0 || y == m - 1;
}

vector <vector <string> > rooms = {
{
    {".W"},    
    {".G"},
    {"WW"}
},
{
    {".G"},
    {".W"},
    {"WW"},
}
};


vector <string> main_pattern(6);

void add(string &s, string t) {
    for (auto ch: t) {
        s += ch;
    }
}

void create_main_pattern() {
    for (int i = 0; i < (m - 3) / 2; ++i) {
        for (int j = 0; j < 6; ++j) {
            add(main_pattern[j], rooms[i % 2][j % 3]);
        }
    }
    for (int j = 0; j < 6; ++j) {
        if (j == 2) {
            add(main_pattern[j], "G");
        } else if (j == 5) {
            add(main_pattern[j], "W");
        } else {
            add(main_pattern[j], ".");
        }
    }
    main_pattern.back()[0] = 'G';
}

void fill(int i) {
    for (int i1 = 0; i1 < 6; ++i1) {
        if (i + i1 >= n - 1) {
            break;
        }
        for (int j = 1; j < m - 1; ++j) {
            room[i + i1][j] = main_pattern[i1][j - 1];
        }
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    n = atoi(argv[1]);
    m = atoi(argv[2]);


    assert(n >= 4);
    assert(m >= 3);
    assert((m - 2) % 2 == 1);
    assert((n - 1) % 3 == 0);

    create_main_pattern();

    room.assign(n, vector <char> (m, 'W'));

    for (int i = 1; i + 2 < n; i += 6) {
        fill(i);
    }

    int x, y;
    if ((n - 1) % 6 == 3) {
        x = n - 2 + m % 4 / 2;
        y = m - 1;
    } else {
        x = n - 2;
        y = 2;
    }

    cout << n << " " << m << endl;
    for (auto &v: room) {
        for (auto &ch: v) {
            cout << ch;
        }
        cout << endl;
    }
    cout << "2 2" << endl;
    cout << x << " " << y << endl;
    return 0;
}