#include <iostream>
#include <string>
#include "testlib.h"

using namespace std;

const int MAXN = 1000;

vector <string> room;
int n, m;

void read_coord() {
	int x = inf.readInt(1, n, "x") - 1;
	inf.readSpace();
	int y = inf.readInt(1, m, "y") - 1;
	inf.readEoln();
	ensuref(room[x][y] == '.', "Start and finish position must be free");
}

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    n = inf.readInt(3, MAXN, "n");
    inf.readSpace();
    m = inf.readInt(3, MAXN, "m");
    inf.readEoln();

    room.resize(n);
    for (auto &s: room) {
    	s = inf.readToken(format("[WG.]{%d}", m), "s_i");
    	inf.readEoln();
    }
    read_coord();
    read_coord();
    inf.readEof();
    for (int i = 0; i < n; ++i) {
    	ensuref(room[i][0] == 'W', "The extreme cells must be walls");
    	ensuref(room[i].back() == 'W', "The extreme cells must be walls");
    }
    for (int i = 0; i < m; ++i) {
    	ensuref(room[0][i] == 'W', "The extreme cells must be walls");
    	ensuref(room.back()[i] == 'W', "The extreme cells must be walls");
    }
}