#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
    #define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
    #define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using D = double;
using uint = unsigned int;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

const int INF = (int)1e8;
const int N = 1010;
const int M = N * N;
string s[N];
int n, m, k;
int col[N][N];
vector<int> G[M];
int curPortal;
vector<string> ans;
const int DX[] = {1, -1, 0, 0};
const int DY[] = {0, 0, 1, -1};
const char DC[] = "DURL";

struct Edge {
	int shootX, shootY, shootDir;
	int goX, goY;
	int v, to;
	
	Edge() : shootX(), shootY(), shootDir(), goX(), goY(), v(), to() {}
	Edge (int _sx, int _sy, int _sdir, int _gx, int _gy, int _v, int _to) :
		shootX(_sx), shootY(_sy), shootDir(_sdir),
		goX(_gx), goY(_gy), v(_v), to(_to) {}
};
Edge ed[M * 4];
int edSz;
int dist[M];
int par[M];
int q[M];
int topQ;
int pp[N][N];
int ut[N][N];
int timer;

void addEdge(int sx, int sy, int sdir, int gx, int gy) {
	int v = col[sx][sy], u = col[gx][gy];
	if (v == -1 || u == -1) return;
	if (v == u) return;
	ed[edSz] = Edge(sx, sy, sdir, gx, gy, v, u);
	G[v].push_back(edSz++);
}

void dfsCol(int x, int y) {
	col[x][y] = k;
	for (int d = 0; d < 4; d++) {
		int xx = x + DX[d], yy = y + DY[d];
		if (col[xx][yy] != -1) continue;
		dfsCol(xx, yy);
	}
}

void buildGraph() {
	for (int y = 0; y < m; y++) {
		int gx = -1;
		for (int x = n - 1; x >= 0; x--) {
			if (s[x][y] == 'W') {
				gx = x - 1;
			} else if (s[x][y] == '.') {
				addEdge(x, y, 0, gx, y);
			}
		}
		gx = -1;
		for (int x = 0; x < n; x++) {
			if (s[x][y] == 'W') {
				gx = x + 1;
			} else if (s[x][y] == '.') {
				addEdge(x, y, 1, gx, y);
			}
		}
	}
	for (int x = 0; x < n; x++) {
		int gy = -1;
		for (int y = m - 1; y >= 0; y--) {
			if (s[x][y] == 'W') {
				gy = y - 1;
			} else if (s[x][y] == '.') {
				addEdge(x, y, 2, x, gy);
			}
		}
		gy = -1;
		for (int y = 0; y < m; y++) {
			if (s[x][y] == 'W') {
				gy = y + 1;
			} else if (s[x][y] == '.') {
				addEdge(x, y, 3, x, gy);
			}
		}
	}
}

void BFS(int v) {
	for (int i = 0; i < k; i++)
		dist[i] = INF;
	dist[v] = 0;
	q[topQ++] = v;
	for (int i = 0; i < topQ; i++) {
		v = q[i];
		for (int id : G[v]) {
			int u = ed[id].to;
			if (dist[u] <= dist[v] + 1) continue;
			par[u] = id;
			dist[u] = dist[v] + 1;
			q[topQ++] = u;
		}
	}
}

void addMove(int d) {
	string p = "M";
	p.push_back(DC[d]);
	ans.push_back(p);
}
void addShot(int d) {
	string p = "";
	if (curPortal == 0)
		p.push_back('B');
	else
		p.push_back('O');
	curPortal ^= 1;
	p.push_back(DC[d]);
	ans.push_back(p);
}

void dfs2(int x, int y) {
	ut[x][y] = timer;
	for (int d = 0; d < 4; d++) {
		int xx = x + DX[d], yy = y + DY[d];
		if (s[xx][yy] != '.' || ut[xx][yy] == timer) continue;
		pp[xx][yy] = d;
		dfs2(xx, yy);
	}
}
void goInOne(int sx, int sy, int tx, int ty) {
	timer++;
	dfs2(tx, ty);
	while(sx != tx || sy != ty) {
		int d = pp[sx][sy] ^ 1;
		addMove(d);
		sx += DX[d];
		sy += DY[d];
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			if (s[i][j] == '.')
				col[i][j] = -1;
			else
				col[i][j] = -2;
		}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			if (col[i][j] != -1) continue;
			dfsCol(i, j);
			k++;
		}
	int sx, sy, tx, ty;
	cin >> sx >> sy >> tx >> ty;
	sx--;sy--;tx--;ty--;
	if (col[sx][sy] == col[tx][ty]) {
		goInOne(sx, sy, tx, ty);
		cout << "0 " << (int)ans.size() << "\n";
		for (string t : ans)
			cout << t << "\n";
		return 0;
	}
	int ssx = -1, ssy = -1;
	int sdir = -1;
	for (int x = 0; sdir == -1 && x < n; x++) {
		for (int y = 0; sdir == -1 && y < m; y++) {
			if (col[x][y] != col[sx][sy]) continue;
			for (int d = 0; d < 4; d++) {
				int xx = x + DX[d], yy = y + DY[d];
				if (s[xx][yy] == 'W') sdir = d;
			}
			if (sdir != -1) {
				ssx = x;
				ssy = y;
			}
		}
	}
	if (sdir == -1) {
		cout << "-1 -1\n";
		return 0;
	}
	buildGraph();
	BFS(col[sx][sy]);
	if (dist[col[tx][ty]] == INF) {
		cout << "-1 -1\n";
		return 0;
	}
	vector<int> path;
	int V = col[tx][ty];
	while(V != col[sx][sy]) {
		path.push_back(par[V]);
		V = ed[par[V]].v;
	}
	reverse(path.begin(), path.end());
	for (int i = 0; i < (int)path.size(); i++) {
		Edge e = ed[path[i]];
		goInOne(sx, sy, e.shootX, e.shootY);
		addShot(e.shootDir);
		goInOne(e.shootX, e.shootY, ssx, ssy);
		if (i == 0) {
			addShot(sdir);
			curPortal ^= 1;
		}
		addMove(sdir);
		sx = ssx = e.goX;
		sy = ssy = e.goY;
		sdir = e.shootDir;
	}
	goInOne(sx, sy, tx, ty);
	
	cout  << (int)path.size() + 1 << " " << (int)ans.size() - (int)path.size() - 1 << "\n";
	for (string t : ans)
		cout << t << "\n";
	
    return 0;
}


